unit rzUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  tarrint = array of integer;

  tnelem = record
    val: integer;
    ind: integer;
  end;

  tarrnelem = array of tnelem;

  telem = record
    arr: tarrnelem;
    delta: integer;
    gruppa: integer
  end;

  tarrelem = array of telem;

function generateASets(tmpA: tarrint): tarrelem;
{---------------------------------------------------}
{      ... }
{ ...                }
{---------------------------------------------------}
{ :                                        }
{   tmpA -                   }
{---------------------------------------------------}
var
  tmpAInd: tarrint;
  i, n: integer;
  tmpEl: telem;
begin
  n:=high(tmpA) - low(tmpA) + 1;
  setlength(tmpAInd, n+1);
  for i:=0 to n do tmpAInd[i]:=0;
  while tmpAInd[n] <> 1 do
    begin
      i:=0;
      while tmpAInd[i] = 1 do
        begin
          tmpAInd[i]:=0; i:=i+1
        end;
      tmpAInd[i]:=1; tmpEl.delta:=0; tmpEl.gruppa:=1;
      for i:=0 to n-1 do
        if tmpAInd[i] = 1 then
          begin
            if tmpEl.arr = nil then
              setlength(tmpEl.arr, 1)
            else
              setlength(tmpEl.arr, high(tmpEl.arr) + 2);
            tmpEl.arr[high(tmpEl.arr)].val:=tmpA[i];
            tmpEl.arr[high(tmpEl.arr)].ind:=i;
            tmpEl.delta:=tmpEl.delta + tmpA[i]
          end;
      if tmpEl.arr <> nil then
        begin
          if result = nil then
              setlength(result, 1)
            else
              setlength(result, high(result) + 2);
          result[high(result)]:=tmpEl;
          setlength(tmpEl.arr, 0)
        end
    end;
  setlength(tmpAInd, 0)
end;

procedure sortArray(var tmpA: tarrelem; tmpUSort: boolean = true);
{---------------------------------------------------}
{      - ...}
{ ...   (/)    }
{---------------------------------------------------}
{ :                                        }
{   tmpA -    ;              }
{   tmpUSort -          }
{---------------------------------------------------}
var
  i, tmpBuf: integer;
  tmpEl: telem;
  fl: boolean;
begin
  fl:=true;
  //      (/) 
  while fl do
    begin
      fl:=false;
      for i:=low(tmpA) to (high(tmpA)-1) do
        if ((tmpA[i].delta > tmpA[i+1].delta) and tmpUSort) or
           ((tmpA[i].delta < tmpA[i+1].delta) and not tmpUSort) then
        begin
          tmpEl:=tmpA[i]; tmpA[i]:=tmpA[i+1];
          tmpA[i+1]:=tmpEl; fl:=true
        end
    end;
  //      ...
  // ...    
  tmpBuf:=tmpA[low(tmpA)].delta;
  for i:=(low(tmpA) + 1) to high(tmpA) do
    if tmpA[i].delta <> tmpBuf then
      begin
        tmpA[i].gruppa:=tmpA[i-1].gruppa + 1;
        tmpBuf:=tmpA[i].delta
      end
    else
      tmpA[i].gruppa:=tmpA[i-1].gruppa
end;

function getACorrent(tmpSA: tarrint; tmpCS: integer; tmpD: boolean = true): tarrelem;
{---------------------------------------------------}
{   ,   -...}
{ ...                        }
{---------------------------------------------------}
{ :                                        }
{   tmpSA -    ;             }
{   tmpCS -     ;  }
{   tmpD -     ...}
{       ... (   )    }
{---------------------------------------------------}
var
  i: integer;
  tmpA: tarrelem;
begin
  tmpA:=generateASets(tmpSA);
  for i:=low(tmpA) to high(tmpA) do
    if tmpA[i].delta > tmpCS then
      tmpA[i].delta:=tmpA[i].delta - tmpCS
    else
      tmpA[i].delta:=tmpCS - tmpA[i].delta;
  sortArray(tmpA);
  //    
  if tmpD then
    begin
      for i:=low(tmpA) to high(tmpA) do
        if tmpA[i].gruppa = tmpA[low(tmpA)].gruppa then
          begin
            if result = nil then
              setlength(result, 1)
            else
              setlength(result, high(result) + 2);
            result[high(result)]:=tmpA[i]
          end
        else exit
    end
  else
    begin
      for i:=high(tmpA) downto low(tmpA) do
        if tmpA[i].gruppa = tmpA[high(tmpA)].gruppa then
          begin
            if result = nil then
              setlength(result, 1)
            else
              setlength(result, high(result) + 2);
            result[high(result)]:=tmpA[i]
          end
        else exit
    end
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  n = 5;
var
  a: tarrint;
  b: tarrelem;
  i, j: integer;
  s: string;
begin
  setlength(a, n);
  memo1.clear; randomize;
  a[0]:=10; a[1]:=25; a[2]:=30; a[3]:=15; a[4]:=45;

  memo1.lines.add('      55 ...' + #13#10 +
                  '...      :' + #13#10);
  b:=getACorrent(a, 55);
  for i:=low(b) to high(b) do
    begin
      s:='';
      for j:=low(b[i].arr) to high(b[i].arr) - 1 do
        s:=s + inttostr(b[i].arr[j].val) + ' (' + inttostr(b[i].arr[j].ind) + ') + ';
      s:=s + inttostr(b[i].arr[high(b[i].arr)].val) + ' (' + inttostr(b[i].arr[high(b[i].arr)].ind) + ')';
      memo1.lines.add(s + ';  = ' + inttostr(b[i].delta))
    end;
  setlength(b, 0);
  memo1.lines.add('');
  memo1.lines.add('      107 ...' + #13#10 +
                  '...      :' + #13#10);
  b:=getACorrent(a, 107, false);
  for i:=low(b) to high(b) do
    begin
      s:='';
      for j:=low(b[i].arr) to high(b[i].arr) - 1 do
        s:=s + inttostr(b[i].arr[j].val) + ' (' + inttostr(b[i].arr[j].ind) + ') + ';
      s:=s + inttostr(b[i].arr[high(b[i].arr)].val) + ' (' + inttostr(b[i].arr[high(b[i].arr)].ind) + ')';
      memo1.lines.add(s + ';  = ' + inttostr(b[i].delta))
    end;
  setlength(b, 0);
  memo1.lines.add('');
  memo1.lines.add('      107 ...' + #13#10 +
                  '...      :' + #13#10);
  b:=getACorrent(a, 107);
  for i:=low(b) to high(b) do
    begin
      s:='';
      for j:=low(b[i].arr) to high(b[i].arr) - 1 do
        s:=s + inttostr(b[i].arr[j].val) + ' (' + inttostr(b[i].arr[j].ind) + ') + ';
      s:=s + inttostr(b[i].arr[high(b[i].arr)].val) + ' (' + inttostr(b[i].arr[high(b[i].arr)].ind) + ')';
      memo1.lines.add(s + ';  = ' + inttostr(b[i].delta))
    end
end;

end.
